--
-- gras bale fruit exchange
--
-- author: upsideDown
-- date: 24.03.2013
-- 
--


grassBale = {};

function grassBale.prerequisitesPresent(specializations)
	--return SpecializationUtil.hasSpecialization(baler, specializations);
	return true
end;

function grassBale:load(xmlFile)
	self.createBale = Utils.overwrittenFunction(self.createBale,grassBale.createBale);
	self.dropBale = Utils.overwrittenFunction(self.dropBale,grassBale.dropBale);
end;

function grassBale:delete()
	
end;

function grassBale:mouseEvent(posX, posY, isDown, isUp, button)
end;

function grassBale:keyEvent(unicode, sym, modifier, isDown)
end;

function grassBale:update(dt)
	
end;

function grassBale:createBale(oldFunc, baleFillType, fillLevel)
	local fT = baleFillType;
	
	
	if fT == Fillable.FILLTYPE_WHEAT_WINDROW or fT == Fillable.FILLTYPE_BARLEY_WINDROW or fT == Fillable.FILLTYPE_DRYGRASS_WINDROW then
		--do nothing	
	elseif fT == Fillable.FILLTYPE_GRASS_WINDROW then
		fT = Fillable.FILLTYPE_DRYGRASS_WINDROW --change grass to drygrass, makes working with e.g. feeder mixer easier
		
	 else
		fT = Fillable.FILLTYPE_WHEAT_WINDROW
	 end
	
    oldFunc(self, fT, fillLevel);
end;


function grassBale:dropBale(oldfunc,baleIndex)
    local bale = self.bales[baleIndex];
    local deltaRealTime = (self.time - self.baleLastPositionTime)/1000;
    local x,y,z = getWorldTranslation(bale.id);
    local rx,ry,rz = getWorldRotation(bale.id);
    --link(getRootNode(), bale.id);

	if self.isServer then
        local baleObject = Bale:new(self.isServer, self.isClient);
        baleObject:load(bale.filename, x,y,z,rx,ry,rz, bale.fillLevel);
		baleObject.fillType = bale.fillType;
        baleObject:register();
		
		--print(bale.filename)
		--print("number of bale object components:")
		--print(baleObject.components[1])
		--setScale(baleObject.components[1],.5,.5,.5)
		
		local lx, ly, lz = bale.lastX, bale.lastY, bale.lastZ;
		setLinearVelocity(baleObject.nodeId, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
		
    end;
	
	
    delete(bale.id);
    table.remove(self.bales, baleIndex);

	
   
end;

function grassBale:draw()

	
end;


function grassBale:onDeactivate()
	
end;